class DataManager {
    data: any = {}

    public getTable(tableName: string) {
        return this.data[tableName];
    }

    public handleData(tableName: string, arr: string[]) {
        // 获取首行提示符
        let tips = arr[0].split(',');
        // 获取第二行字段类型
        let types = arr[1].split(',');
        // 获取第三行字段名字
        let names = arr[2].split(',');

        // 处理剩余数据
        let table: any = {};
        for (let i = 3; i < arr.length; i++) {
            let single = arr[i].split(/,/g);
            let obj = this.singleData(names, types, single, tableName, single[0]);
            let key = single[0];
            table[key] = obj;
        }

        // 加入表格
        this.data[tableName] = table;
    }


    private singleData(names: any, types: any, single: string[], tableName: any, taK: any) {
        let obj:any = {};
        for (let i = 0; i < single.length; i++) {
            // 如果字段不存在则跳过
            if (!names[i]) {
                continue;
            }
            // 去除空格
            let key = names[i].replace(/\b\s*/g, "");
            let value = single[i].replace(/\b\s*/g, "");
            let typeName = types[i].replace(/\b\s*/g, "");

            // 区分字段类型
            if (typeName == 'string') {
                obj[key] = value;
            } else if (typeName == "number") {
                obj[key] = Number(value);
            }
        }
        return obj;
    }

    public GetTableByType(name: any, typename: any, type: any) {
        let list = [];
        let table = this.getTable(name);
        for (let i in table) {
            if (table[i][`${typename}`] == type) {
                list.push(table[i]);
            }
        }
        return list;
    }

    public GetTableByID(name: string, id: Number) {
        let tabeldata;
        let table = this.getTable(name);
        for (let i in table) {
            if (table[i].id == id) {
                tabeldata = table[i];
                return tabeldata;
            }
        }
        return tabeldata;
    }
}

export default new DataManager();
