import { JsonAsset, loader, resources } from "cc";

/**
 * @description JSON表模块
 */
class configTableMgr {
	////////////////////////////
	// 类成员
	///////////////////////////
	public static readonly _instance = new configTableMgr();
	private configTableMap:any = {};
	////////////////////////////
	// get、set访问器
	///////////////////////////

	////////////////////////////
	// 接口
	///////////////////////////
	/**
	 * @description 加载json文件夹
	 * @param pathName
	 */
	public loadConfigTable(pathName: string) {
		return new Promise<void>((resolve, reject) => {
			resources.loadDir(pathName, JsonAsset, (err: any, resource: any[]) => {
				if (err) {
					console.error('=====> @framework, 加载配置表失败: ', err);
					reject();
					return;
				}
				resource.forEach((jsonAsset: any) => {
					this.configTableMap[jsonAsset.name] = jsonAsset.json;
				});
				resolve();
			})
		});
	}

	/**
	 * @description 获取json文件
	 * @param jsonName
	 */
	public getConfigTableItem(jsonName: string) {
		let item = this.configTableMap[jsonName];
		if (item) {
			return item;
		} else {
			console.error(`=====> @framework, 获取配置表文件失败, 文件:${jsonName}.json 不存在`);
			return null;
		}
	}



	/**
	 * 获取自选关卡数据
	 */
	getSelfCreatorData() {
		return this.getConfigTableItem('selfCreator');
	}

}

export const ConfigTableMgr = configTableMgr._instance;
