import global from "../../../config/global";
import { NetworkMgr } from "../networkMgr";


class http {
	////////////////////////////
	// 类成员
	///////////////////////////
	public static readonly _instance = new http();
	private _timeOut = 10 * 1000;
	private _httpUrl = 'https://minigame.xmtyq.com/';
	/**加密参数 */
	private DES3_KEY: string = "qXSdHWfbSZaaLeHTTxGZQLXY";
	////////////////////////////
	// get、set构造器
	///////////////////////////
	public set timeOut(time: number) {
		this._timeOut = time;
	}

	public set httpUrl(url: string) {
		this._httpUrl = url;
	}

	////////////////////////////
	// 构造函数
	///////////////////////////
	public constructor() {
	}

	public init(httpUrl: string) {
		this._httpUrl = httpUrl;
	}

	/**
	 * 发送请求
	 * @param route 注册事件，通过消息机制返回服务端回调的信息
	 * @param msg 请求数据
	 * @param mid 
	 */
	public post(route: string, msg: Object, mid?: number) {
		var dataStr = "";
		if (msg) {
			dataStr = JSON.stringify(msg);
		}
		let xhr = new XMLHttpRequest();//cc.loader.getXMLHttpRequest();
		// 超时时间1s，单位是毫秒
		xhr.timeout = this._timeOut;
		xhr.open('POST', this._httpUrl + route, true);
		// 服务端也需要设置
		xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		//DES3加密
	//	console.log(dataStr);
		dataStr = this.strToDES3(dataStr);
		xhr.send('data=' + dataStr);
		xhr.onreadystatechange = function onreadystatechange() {
			// 请求完成。在此进行处理。
			if (xhr.readyState === 4 && (xhr.status >= 200 && xhr.status < 300)) {
				let respone: any = xhr.responseText;
				if (!respone) {
					// console.error('http request respone is null');
					NetworkMgr.onHttpError(mid, null, 'http request respone is null');
					return;
				}
				NetworkMgr.checkRespone(route, respone, mid);
			}
		}.bind(this);

		// XMLHttpRequest 超时
		xhr.ontimeout = function ontimeout(error:any) {
			console.error('http request timeout: ', error);
			NetworkMgr.onHttpError(mid, error, 'http request timeout: ');
		}.bind(this);

		// XMLHttpRequest 错误
		xhr.onerror = function onerror(error:any) {
			// console.error('http request error: ', error);
			NetworkMgr.onHttpError(mid, error, 'http request error: ');
			// alert('网络通信失败，请刷新重试。');
		}.bind(this);
	}

	/**
	 * GET 请求
	 * @param route 
	 * @param msg 
	 * @param mid 
	 */
	public post2(route: string, msg: Object, mid?: number) {
		const str = this.MsgToString(msg)
		let xhr = new XMLHttpRequest();
		// 超时时间1s，单位是毫秒
		xhr.timeout = this._timeOut;
		xhr.open('GET', this._httpUrl + route + "?" + str, true);
		// 服务端也需要设置
		xhr.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
		xhr.send(JSON.stringify(msg));
		xhr.onreadystatechange = function onreadystatechange() {
			// 请求完成。在此进行处理。
			if (xhr.readyState === 4 && (xhr.status >= 200 && xhr.status < 300)) {
				// console.log("返回"+xhr);
				let respone: any = xhr.responseText;
				if (!respone) {

					// console.error('http request respone is null');
					NetworkMgr.onHttpError(mid, null, 'http request respone is null');
					return;
				}
		//		console.log("服务端设置");

		//		console.log(respone);

				NetworkMgr.checkRespone(route, respone, mid);
			}
		}.bind(this);

		// XMLHttpRequest 超时
		xhr.ontimeout = function ontimeout(error:any) {
			console.error('http request timeout: ', error);
			// NetworkMgr.onHttpError(mid, res, 'http request timeout: ');
		}.bind(this);

		// XMLHttpRequest 错误
		xhr.onerror = function onerror(error:any) {
			NetworkMgr.onHttpError(mid, error, 'http request error: ');
		}.bind(this);

	}

	/**
	 * Get请求，将json转换成字符串数据
	 */
	MsgToString(msg: any): string {
		let arr = Object.keys(msg);
		let str = "";
		for (let value of arr) {
			str += value + "=" + '"' + msg[value] + '"' + "&"
		}
		return str;
	}

	/**
	 * 数据加密
	 */
	strToDES3(data:any): any {
		// let des3Data: string = window["DES3"].encrypt(this.DES3_KEY, data);
		// let newData = des3Data.replace(/\+/g, "%2B");
		// return newData;
	}
}

export const Http = http._instance;
