// @ts-nocheck

import { _decorator, Component, Node, BoxColliderComponent, RigidBodyComponent, Sprite } from 'cc';
import { objectscrtip } from './objectscrtip';
import { SaveAs } from './FileSaver';
import global from '../config/global';
const { ccclass, property } = _decorator;

@ccclass('LevelGame')
export class LevelGame extends Component {
    @property({
        tooltip: "关卡",
    })
    level: number = 0;


    @property({
        type: Node
    })
    btn: Node = null;

    // @property({
    //     type: Node,
    //     tooltip: "玩家",
    // })
    // player: Node = null;

    public blob: any;
    onLoad() {
        this.btn.on('click', () => {
            SaveAs(this.blob, "level" + this.level + ".csv");
        });
    }

    start() {
        if (this.node.active == true) {
            this.btn.active = true;
            this.btn.parent.active = true;
        } else {
            this.btn.active = false;
        }
        this.scheduleOnce(this.check, 1);
    }

    check() {
        var data1 = '';
        var index = 0;
        var da = '索引,' + '节点名字,' + 'posX,' + 'posY,' + 'posZ,' + 'rotX,' + 'rotY,' + 'rotZ,' + 'ScaX,' + 'ScaY,' + 'ScaZ,' + 'Type' + 'Type2' + '\n' +
            'number,' + 'string,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number' + 'number' + '\n' +
            'ID,' + 'name,' + 'posX,' + 'posY,' + 'posZ,' + 'rotX,' + 'rotY,' + 'rotZ,' + 'ScaX,' + 'ScaY,' + 'ScaZ,' + 'Type' + 'Type2' + '\n';
        data1 += da;
        for (let value of this.node.children) {
            index++;
            var type = 0;
            const nodeName = value.name;
            //道具分组
            if (nodeName == "prefab_group") {
                da = this.getNodeValueStr(value, index, type);
                data1 += da;
                for (let value2 of value.children) {
                    index++;
                    var type2 = 0;
                    const nodeName2 = value2.name;
                    var moveLength = 0;
                    //特殊处理的道具 
                    if (global.arrProp.indexOf(nodeName2) > -1) {
                        type2 = value2.getComponent(Props).Value;
                        moveLength = value2.getComponent(Props).moveLength;
                    }
                    da = this.getNodeValueStr(value2, index, type2, moveLength);
                    data1 += da;
                }
                continue;
            }
            if (nodeName == "prefab_curve") {
                type = value.getComponent(prefab_curve).anger;
            }
            da = this.getNodeValueStr(value, index, type);
            data1 += da;
        }
        var content = data1;
        this.blob = new Blob([content], { type: "text/csv;charset=utf-8" });
    }

    getNodeValueStr(node: Node, index: number, type: number, type2 = 0): string {
        let str = index + ',' + node.name + "," + Number(node.position.x.toFixed(3)) + "," + Number(node.position.y.toFixed(3)) + "," +
            Number(node.position.z.toFixed(3)) + "," + Number(node.eulerAngles.x.toFixed(3)) + "," + Number(node.eulerAngles.y.toFixed(3)) + "," +
            Number(node.eulerAngles.z.toFixed(3)) + "," +
            Number(node.scale.x.toFixed(3)) + ',' + Number(node.scale.y.toFixed(3)) + "," + Number(node.scale.z.toFixed(3)) + "," + type + "," + type2 + '\n';
        return str;
    }
}
