import { instantiate, Node, NodePool, Prefab } from "cc";

class poolMgr {
    public static readonly _instance = new poolMgr();
    private poolArry: any = {};      //对象池组
    /**
     * 创建对象池
     * @param cPrefab 预制体
     * @param count 要创建的数量
     */
    public creatorPool(cPrefab: Prefab, count: number): void {
        let cPool = new NodePool();
        for (let i = 0; i < count; i++) {
            let node = instantiate(cPrefab);
            cPool.put(node);
        }
        //对象池JSON 用预制体名字做key
        this.poolArry[cPrefab.data.name] = {
            nodePool: cPool
        }
    }

    /**
  * 回收对象池
  * @param node 要回收的节点
  */
    public recoveryPool(node: Node): void {
        let poolName = node.name;
        if (this.poolArry[poolName]) {
            this.poolArry[poolName].nodePool.put(node)
        }
        else {
            console.error("objLayer no this pool", poolName);
            node.destroy();
        }
    }

    /**
  * 获取对象池节点
  * @param cPrefab 预制体名称 
  */
    public getPoolObj(cPrefab: Prefab): Node {
        let prefabName = cPrefab.data.name;
        if (this.poolArry[prefabName] && this.poolArry[prefabName].nodePool.size() > 0) {
            return this.poolArry[prefabName].nodePool.get();
        } else {
            this.creatorPool(cPrefab, 1);
            return this.poolArry[prefabName].nodePool.get();
        }
    }
}
export const PooLMgr = poolMgr._instance;