import { sys, Node, loader, Prefab, instantiate, randomRange, isValid, resources, assetManager, AssetManager, log } from "cc";
import { Http } from "./http";
import { NetworkMgr } from "./networkMgr";
import { Toutiao } from "./tyqToutiao";
import tyqSdkConfig from "./tyq-sdk-config";
import { tyq_crazyBox } from "./tyq_crazyBox";
import { tyq_gameItemMini } from "./tyq_gameItemMini";
import { tyq_luckyBox } from "./tyq_luckyBox";
import { tyq_main } from "./tyq_main";
import { tyq_share } from "./tyq_share";
import { tyq_settlePanel } from "./tyq_settlePanel";
/**游戏数据 */
export interface gameInfo {
    gameName: string,
    gameImg: string,
    gameTips: string,
    gameVideID: string,
    gameID: any
}

/**SDK 类 */
class tyqSdk {
    public static readonly _instance = new tyqSdk();
    /**剪辑视频的路径 */
    private videoRes: string = "";
    /**玩家在首页倒计时观看视频 */
    private mainWatch: any = null;
    /**所有SDK UI的父节点 */
    private canvasNode: Node | null = null;
    /**主页 */
    private tyq_main: Node | null = null;
    /**退出按钮 */
    private tyq_exit: Node | null = null;
    /**更多游戏面板 */
    private tyq_moreGamePanel: Node | null = null;
    /**发布视频icon */
    private tyq_shareVideo: Node | null = null;
    /**是否正在加载视频 */
    private isVideo: boolean = false;
    /**开关对象合集 */
    private switch_info: any = {};
    /**总开关 1是开 0是关*/
    private master_switch: number = 0;
    /**场景值 判断和系统获取的场景值是否一致，一致为套路 */
    private scene_id: string = "";
    /**当前的场景值 系统获取*/
    private LaunchOptionsSync: any = null;
    /**今天玩的关卡 */
    private levelCunt: number = 1;
    /**总开关 缓存版 true为套路版 false纯净版*/
    private masterSwitch: boolean = true;
    /**总开关 不缓存  true为套路版 false纯净版*/
    private allSwitch: boolean = true;
    /**用户唯一openID */
    private openid: string = ""
    /**游玩时间 */
    private _playTime: number = 0;
    /**观看视频时间 */
    private _videoTime: number = 0;
    /**关卡 */
    private _gameLevel: string = "";
    /**体力 */
    private physical: number = 0;
    /**钻石 */
    private diamonds: number = 0;
    /**是否是vip，vip当天免体力 */
    private vip: boolean = false;
    /**分包 */
    private bundlePack: AssetManager.Bundle | null = null;
    /**游戏数据，先写死，后面改成动态的 */
    public gameList: gameInfo[] = [{ gameName: "魔性变变变", gameImg: "dy_tyqSDK/res/gameBox/ui_icon1", gameTips: "180万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c52544d4c0a7d406c5f51424700734063", gameID: 1 },
    { gameName: "假如学生爱写作业", gameImg: "dy_tyqSDK/res/gameBox/ui_icon2", gameTips: "57万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c52544d4208734564555c4d4c0e7c4766", gameID: 1 },
    { gameName: "赛几美食街", gameImg: "dy_tyqSDK/res/gameBox/ui_icon3", gameTips: "99万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c52504247097843615153414700734c64", gameID: 1 },
    { gameName: "星座狗跑酷", gameImg: "dy_tyqSDK/res/gameBox/ui_icon4", gameTips: "66万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c525042470e7f41605e524543007e4063", gameID: 1 },
    { gameName: "赛几探险记", gameImg: "dy_tyqSDK/res/gameBox/ui_icon5", gameTips: "81万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c52504241087b4d61565746450d7d436c", gameID: 1 },
    { gameName: "赛几美食街", gameImg: "dy_tyqSDK/res/gameBox/ui_icon6", gameTips: "3.6万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c525042460a7a4763545445410e784d65", gameID: 1 },
    { gameName: "星座狗跑酷", gameImg: "dy_tyqSDK/res/gameBox/ui_icon7", gameTips: "59万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c525042470e7f41605e524543007e4063", gameID: 1 },
    { gameName: "假如学生爱写作业", gameImg: "dy_tyqSDK/res/gameBox/ui_icon8", gameTips: "9.8万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c52544d4d09794166535646400e734561", gameID: 1 },
    { gameName: "魔性变变变", gameImg: "dy_tyqSDK/res/gameBox/ui_icon9", gameTips: "10.7万人最近在玩", gameVideID: "13104c4c0e7f1231035c45430d2e476453564446677c4d6c52554444087d446153524c4c017f4463", gameID: 1 }]

    public gameBannerList: gameInfo[] = [];

    constructor() {
    }

    /**初始化SDK,获取开关 只需传成功回调，因为成功失败都会进入场景*/
    public init(success: Function) {
        //以上代码是游玩统计
        this.LaunchOptionsSync = Toutiao.LaunchOptionsSync();
        if (tyqSdkConfig.webTest) {
            this.LaunchOptionsSync = {
                scene_id: "990001",
                query: {}
            }
        }
        //初始化SDK
        var time = this.getTimeStamp(false, true);//获取到毫秒的时间戳，精确到毫秒
        let info = {
            appid: tyqSdkConfig.appId,
            nonce_str: this.randomStr(),
            time_stamp: time,
            app_version: tyqSdkConfig.app_version,
        }
        NetworkMgr.xhrPost("douyin_game_sdk/api/v1/switch_info", info, (cb: any) => {
            console.log(cb);
            if (cb.data) {
                this.switch_info = cb.data.switch_info;
                this.master_switch = cb.data.master_switch;
                this.scene_id = cb.data.scene_id;
                this.initMasterSwitch(cb.data.switch_v1, cb.data.switch_v2);
                this.initAdUnitId(cb.data.dy_ad_id);
                this.initGameList();
                this.addLevel(true);
            }
            if (success) {
                success();
                this.login();
                return;
            }
        }, () => {
            if (success) {
                success();
            }
        });
        this.initDiamondsAndPhysical();
    }


    /**
     *  根据开关名称获取是否使用套路版
     * @param str 开关的名称 不传直接获取总开关
     * @param value 是否需要对比的值 如果传入这个参数，那么会和开关的值做对比，只有存在这个值，才会返回true
     * @returns false 是关， true 是开
     */
    public getSwitchInfoByName(str?: string, value?: number): boolean {
        if (!this.masterSwitch) return false;
        if (str) {
            if (!this.switch_info[str]) {//不存在这个开关
                console.log(str + "开关不存在");
                return false
            } else {
                let valueList: string[] = this.switch_info[str].split(",");
                //分两种情况，有传value和没有value
                if (value) {
                    if (valueList.indexOf(value.toString()) == -1) return false;
                } else {
                    if (valueList.indexOf("0") > -1) return false;//0是关，有0表示关
                }
                return true;
            }
        } else {
            return true;
        }
    }

    /**根据开关名称获取是否使用套路版 使用这个接口不受场景值影响 只受总开关和小开关影响 用法和getSwitchInfoByName一样 */
    public getSwitchByName(str?: string, value?: number): boolean {
        if (!this.allSwitch) return false
        if (str) {
            if (!this.switch_info[str]) {//不存在这个开关
                console.log(str + "开关不存在");
                return false
            } else {
                let valueList: string[] = this.switch_info[str].split(",");
                //分两种情况，有传value和没有value
                if (value) {
                    if (valueList.indexOf(value.toString()) == -1) return false;
                } else {
                    if (valueList.indexOf("0") > -1) return false;//0是关，有0表示关
                }
                return true;
            }
        } else {
            return true;
        }
    }

    /**直接获取开关值 */
    public getSwitchValue(str: string): any {
        if (!this.switch_info[str]) {//不存在这个开关
            console.log(str + "开关不存在");
            return 0
        } else {
            return this.switch_info[str];
        }
    }

    /**
     * 首次进入游戏场景时调用，只需要调用一次,重复调用不会改变父节点
     * @param allParent 所有SDK的UI的父节点，建议新建一个Canvas,将Canvas的渲染层级调到最高级,避免遮挡
     */
    public inGameScene(allParent: Node) {
        if (this.canvasNode) return;
        this.canvasNode = allParent;
        if (!this.tyq_exit) {
            if (this.getSwitchInfoByName("exit")) {
                this.loadPrefab("prefab/tyq_exit", (node: Node) => {
                    this.tyq_exit = node;
                    node.parent = this.canvasNode;
                });
            }
        }
        this.showLuckDraw();
        if (!this.tyq_main) {
            this.showMain();
        }
    }

    /**进入主页的时候调用 */
    public showMain() {
        //玩家进入主页，n秒不动调用视频
        if (this.getSwitchInfoByName("noOperationADTime")) {
            let num = Number(this.getSwitchValue("noOperationADTime"));
            this.mainWatch = setTimeout(() => {
                this.noOperationPlayAD(num * 1000);
            }, num * 1000);
        }
        if (!this.tyq_main) {
            this.loadPrefab("prefab/tyq_main", (node: Node) => {
                this.tyq_main = node;
                if (this.canvasNode) {
                    node.setParent(this.canvasNode);
                } else {
                    console.log("没有找到父节点");
                }
            })
        } else {
            tyq_main.getInstance()?.showMain();
        }
        //达人版展示一个上传视频按钮
        if (!this.tyq_shareVideo && this.LaunchOptionsSync.query.tiktoker_user_id) {
            this.loadPrefab("prefab/tyq_shareVideo", (node: Node) => {
                this.tyq_shareVideo = node;
                if (this.canvasNode) {
                    node.setParent(this.canvasNode);
                }
            })
        }
    }

    /**隐藏主页  */
    public hideMain() {
        if (this.tyq_main) {
            tyq_main.getInstance()?.hideMain();
        }
        if (this.tyq_shareVideo) {
            this.tyq_shareVideo.destroy();
            this.tyq_shareVideo = null;
        }
        this.outMain();
    }

    /**每次玩家在主界面操作时，不管是设置还进入皮肤商店，都调用一次这个函数 作用是为了打断计时器 重复调用无影响*/
    public outMain() {
        if (this.mainWatch) {
            clearTimeout(this.mainWatch);
            this.mainWatch = null;
        }
    }

    /**游戏开始时调用 
     * @param level 关卡 如果是特殊关卡，传特殊关卡名称即可
     * @param inGameFun 真正开始游戏的方法
    */
    public startGame(level: any, inGameFun: Function) {
        this.outMain();
        if (this.Physical <= 0) {
            this.showPhysicalPanel();
            return;
        }
        if (typeof (level) == "number") {
            this._gameLevel = level.toString();
        } else {
            this._gameLevel = level;
        }
        this.collectLevelInfo();
        this.hideMain();
        if (this.tyq_exit) {
            this.tyq_exit.active = false;
        }
        this.Physical = -1;
        //游戏开始调用狂点宝箱  这里要区分套路版
        if (!this.getSwitchInfoByName("crazyBox", this.levelCunt)) {
            inGameFun();
            this.screencap();
            return;
        }
        this.loadPrefab("prefab/tyq_crazyBox", (node: Node) => {
            if (this.canvasNode) {
                node.setParent(this.canvasNode);
                node.getComponent(tyq_crazyBox)!.inint(() => {
                    inGameFun();
                    this.screencap();
                });
            }
        })
    }


    /**
     * 游戏结束时调用
     * @param gameType 过关状态，传win或者lose字符串，不是通关的游戏也传win
     * @param nextFun 进入下一关（或者结算界面）的方法传进来
     */
    public endGame(gameType: string = "win", nextFun: Function) {
        this.stopScreencap();
        this.collectLevelInfo(gameType == "win" ? 2 : 3);
        if (this.tyq_exit) {
            this.tyq_exit.active = true;
        }
        if (!this.getSwitchInfoByName("endGameAD", this.levelCunt)) {
            this.loadPrefab("prefab/tyq_share", (node: Node) => {
                node.setParent(this.canvasNode);
                node.getComponent(tyq_share)!.init(() => {
                    this.showLuckBox(gameType, nextFun);
                })
            });
        } else {
            this.showVideoAD("结束视频拉取", () => {
                this.loadPrefab("prefab/tyq_share", (node: Node) => {
                    node.setParent(this.canvasNode);
                    node.getComponent(tyq_share)!.init(() => {
                        this.showLuckBox(gameType, nextFun);
                    })
                })
            }, () => {
                this.loadPrefab("prefab/tyq_share", (node: Node) => {
                    node.setParent(this.canvasNode);
                    node.getComponent(tyq_share)!.init(() => {
                        this.showLuckBox(gameType, nextFun);
                    })
                })
            });
        }
        if (gameType == "win") {
            this.addLevel();
        }
    }

    /**
     * 关卡+1
     * @param isLoad 是否是初始化
     */
    private addLevel(isLoad: boolean = false) {
        const curTime = this.getTimeStamp(true)//精确到日期
        const lastTime = this.getItem("gameTime");
        //判断上次玩的时间是否经过一天
        if (this.getItem("gameTime")) {
            //游戏时间没有过一天
            if (lastTime == curTime) {
                this.levelCunt = this.getItem("levelCunt") ? this.getItem("levelCunt") : this.levelCunt;
                if (!isLoad) {
                    this.levelCunt++;
                }
            } else {//过了一天 从第一关统计
                this.setItem("gameTime", curTime);
                this.levelCunt = 1;
            }
        } else {
            this.setItem("gameTime", curTime);
            this.levelCunt = 1;
        }
        this.setItem("levelCunt", this.levelCunt);
        //以上代码是游玩统计
    }
    /**
     * 拉取视频广告
     * @param why 为什么观看广告
     * @param success 成功回调
     * @param fail 失败回调
     */
    public showVideoAD(why: string, success?: Function, fail?: Function) {
        if (sys.platform != sys.BYTEDANCE_GAME) {
            console.log("不是抖音端");
            if (success)
                success();
            return
        };
        if (this.isVideo) {
            if (fail) {
                fail();
            }
            return;
        };
        this.isVideo = true;
        Toutiao.showRewardVideoAd(why)!.then(() => {
            this.isVideo = false;
            //成功观看视频
            if (success) {
                success();
            }
        }, () => {
            this.isVideo = false;
            //失败
            if (fail) {
                fail();
            }
        })
    }

    /**展示插屏广告 */
    public showInterstitialAD() {
        if (sys.platform != sys.BYTEDANCE_GAME) {
            console.log("不是抖音端");
            return;
        }
        Toutiao.showInterstitialAd();
    }

    /**
     * 展示Banner广告
     */
    public showBannerAD() {
        Toutiao.showBannerAd();
    }

    public hideBannerAD() {
        Toutiao.hideBannerAd();
    }

    /**展示游戏盒子 */
    public showMoreGame() {
        Toutiao.showMoreGamesModal();
    }

    /**获取随机数 */
    public RandomNumBoth(Min: number, Max: number): number {

        var Range = Max - Min;

        var Rand = Math.random();

        var num = Min + Math.round(Rand * Range); //四舍五入

        return num;

    }

    /**分享视频 */
    public RecordCut(fun?: Function, target?: Object, info?: Object, index: number = -1) {
        var _query = null;
        if (this.LaunchOptionsSync.query.tiktoker_user_id) {
            const randNum = this.RandomNumBoth(100000, 999999);
            var times = this.getTimeStamp();
            var str = "v-" + this.LaunchOptionsSync.query.tiktoker_user_id + "-" + times + "-" + randNum;
            _query = "video_uuid=" + str;
        }
        console.log(_query);
        Toutiao.shareAppMessage(index > -1 ? this.gameList[index].gameName : tyqSdkConfig.gameName, this.videoRes, ["抖音小游戏", tyqSdkConfig.gameName], _query)?.then((res) => {
            if (this.LaunchOptionsSync.query.tiktoker_user_id) {
                this.tiktokAddVideo(times, info, str);
            }
            if (fun) {
                fun.call(target, res);
            }
        }, () => {
            console.log('分享视频失败');
        })
    }

    /**达人发布视频 */
    private tiktokAddVideo(time: any, data: any, videoID: any) {
        const str = time;
        const curTime = str.substr(0, 10);//精确到秒
        let info = {
            appid: tyqSdkConfig.appId,
            nonce_str: this.randomStr(),
            time_stamp: curTime,
            nick_name: data.userInfo.nickName,
            avatar_url: data.userInfo.avatarUrl,
            video_uuid: videoID,
            tiktoker_user_id: this.LaunchOptionsSync.query.tiktoker_user_id
        }
        NetworkMgr.xhrPost("douyin_game_sdk/api/v1/tiktok_add_video", info);
    }

    /**跳转视频播放
     * @param VIDEOID 视频ID
     * @param umaInfo 友盟统计数据
     */
    public navigateToVideoView(value: gameInfo, from: string) {
        console.log(value);
        Toutiao.navigateToVideoView(value.gameVideID, from);
        if (!this.openid) return;
        const time = this.getTimeStamp(false, true);
        let info = {
            appid: tyqSdkConfig.appId,
            nonce_str: this.randomStr(),
            time_stamp: time,
            htw_ads_id: value.gameID,
            openid: this.openid,
        }
        NetworkMgr.xhrPost("douyin_game_sdk/api/v1/collect_htw_ads_click", info);
    }


    /**展示更多游戏面板（这个是我们自己做的游戏盒子） 
     * @param isGamebox 是否是通过点击游戏盒子打开
    */
    public showMoreGameBoxPanel(isGamebox = false) {
        //这里要做开关控制 如果不是通过icon打开，要判断关卡是否允许开启游戏盒子
        if (!isGamebox && !this.getSwitchInfoByName("showMoreGameBoxPanel", this.levelCunt - 1)) return;
        this.outMain();
        if (!this.tyq_moreGamePanel) {
            this.loadPrefab("prefab/tyq_moreGamePanel", (node: Node) => {
                this.tyq_moreGamePanel = node;
                if (this.canvasNode) {
                    node.setParent(this.canvasNode);
                } else {
                    console.log("没有找到父节点");
                    node.destroy();
                }
            })
        } else {
            this.tyq_moreGamePanel.active = true;
        }
    }

    /**隐藏更多游戏面板 */
    public hideMoreGameBoxPanel() {
        if (this.tyq_moreGamePanel) {
            this.tyq_moreGamePanel.active = false;
        }
    }

    /**
     * 收集用户点击事件
     * @param event 时间名称
     */
    public collectClickEvent(event: string) {
        if (!this.openid) return;
        var time = this.getTimeStamp(false, true);
        let info = {
            appid: tyqSdkConfig.appId,
            nonce_str: this.randomStr(),
            time_stamp: time,
            openid: this.openid,
            event_id: event,
        }
        NetworkMgr.xhrPost("douyin_game_sdk/api/v1/collect_click_event", info);
    }

    /**
     * 收集广告视频行为
     * @param status 广告状态。1 拉取成功（视频请求pv） 2 广告展示(视频曝光pv) 3 视频完整播放 4 视频中途关掉（这个要上传play_time）
     */
    public collectAdAction(status: number) {
        if (!this.openid) return;
        var time = this.getTimeStamp();
        let curTime = Number(time);
        time = time.substr(0, 10);//精确到秒
        if (status == 2) {//展示成功开始计算时间
            this._videoTime = curTime;
        } else if (status == 3) {//播放完整清楚时间
            this._videoTime = 0;
        } else if (status == 4) {//中途关掉
            this._videoTime = curTime - this._videoTime;
        }
        let info = {
            appid: tyqSdkConfig.appId,
            nonce_str: this.randomStr(),
            time_stamp: time,
            openid: this.openid,
            status: status,
            play_time: this._videoTime,
        }
        NetworkMgr.xhrPost("douyin_game_sdk/api/v1/collect_ad_action", info);
    }

    /**随机字符串*/
    private randomStr(strLen: number = 32) {
        let len = strLen;
        let $chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678'; /****默认去掉了容易混淆的字符oOLl,9gq,Vv,Uu,I1****/
        let maxPos = $chars.length;
        let pwd = '';
        for (let idx = 0; idx < len; idx++) {
            pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
        }
        return pwd;
    }
    /**
        * 获取缓存数据
        * @param key 键名
        */
    public getItem(key: string): any {
        let data = localStorage.getItem(key);
        return data ? (data[0] == "[" || data[0] == "{" ? JSON.parse(data) : data) : null;
    }
    /**
     * 缓存数据
     * @param key 键名
     * @param value 值
     */
    public setItem(key: string, value: string | object | number): void {
        let data = typeof value === 'string' ? value : JSON.stringify(value);
        localStorage.setItem(key, data);
    }

    /**获取钻石 */
    public get Diamonds() {
        return Number(this.diamonds);
    }
    /**获取体力 */
    public get Physical() {
        return Number(this.physical);
    }

    /**设置钻石 */
    public set Diamonds(num: number) {
        this.diamonds += Number(num);
        this.setItem("tyq_diamonds", this.diamonds);
        try {
            tyq_main.getInstance()?.changePhy();
        } catch {
            console.error("没有tyqmian");
        }

    }
    /**设置体力 */
    public set Physical(num: number) {
        this.physical += Number(num);
        this.setItem("tyq_physical", this.physical);
        try {
            tyq_main.getInstance()?.changePhy();
        } catch {
            console.error("没有tyqmian");
        }
    }

    /**获取vip状态 */
    public get Vip() {
        return this.vip;
    }

    public set Vip(bool: boolean) {
        this.vip = bool;
    }

    /**展示幸运抽奖界面 */
    public showLuckDraw() {
        this.loadPrefab("prefab/tyq_luckDraw", (node: Node) => {
            if (this.canvasNode) {
                node.parent = this.canvasNode;
            }
        })
    }

    /**
     * 删除缓存数据
     * @param key 键名
     */
    private removeItemByKey(key: string): void {
        localStorage.removeItem(key);
    }
    /**
     * 清空缓存数据
     */
    private clear() {
        localStorage.clear();
    }



    /**加载预制体 */
    private loadPrefab(url: string, callback: Function) {
        this.loadBunle().then(() => {
            this.bundlePack!.load(url, Prefab, (err: any, prefab: Prefab) => {
                if (err) {
                    console.log("加载" + url + "失败");
                    console.log(err);
                    return;
                }
                let prefabNode = instantiate(prefab);
                if (callback) {
                    callback(prefabNode);
                }
            })
        })

    }

    /**加载AB包 */
    private loadBunle() {
        let url = "dy_tyqSDK";
        return new Promise<AssetManager.Bundle | void>((resolve, reject) => {
            if (this.bundlePack) {//如果存在直接返回AB包
                resolve();
            } else {
                assetManager.loadBundle(url, (err, bundle) => {
                    if (err) {
                        console.error(url + "加载失败");
                        reject();
                        return;
                    }
                    this.bundlePack = bundle;
                    resolve();
                })
            }
        })
    }

    /**开始录屏 */
    private screencap() {
        console.log("开始录屏");
        Toutiao.startRecordScreen(300)
    }


    /**
    * 停止录屏
    */
    private stopScreencap() {
        Toutiao.stopRecordScreen((path: string) => {
            Toutiao.clipVideo(300, path, (res: any) => {
                console.log("停止录屏");
                console.log(res);
                this.videoRes = res.videoPath;
            })
        })
    }


    /**展示幸运宝箱 */
    private showLuckBox(gameType: string, nextFun: Function) {
        if (this.getSwitchByName("luckyBox")) {
            this.loadPrefab("prefab/tyq_luckyBox", (node: Node) => {
                node.setParent(this.canvasNode);
                node.getComponent(tyq_luckyBox)!.init(() => {
                    this.showSettlePanel(gameType, nextFun);
                });
            })
        } else {
            this.showSettlePanel(gameType, nextFun);
        }
    }

    /**展示结算页面  */
    private showSettlePanel(gameType: string, nextFun: Function) {
        if (this.getSwitchByName("settlePanel")) {
            this.loadPrefab("prefab/tyq_settlePanel", (node: Node) => {
                node.setParent(this.canvasNode);
                node.getComponent(tyq_settlePanel)!.init(gameType, nextFun);
            })
        }else{
            nextFun();
        }
    }

    /**展示体力页面 */
    private showPhysicalPanel() {
        this.loadPrefab("prefab/tyq_physicalPanel", (node: Node) => {
            node.setParent(this.canvasNode);
        })
    }

    /**
     * 初始化总开关
     * @param version1 版本1的广告开关 1是开  0是关
     * @param version2 版本2的广告开关 1是开  0是关
     * @returns 
     */
    private initMasterSwitch(version1: number, version2: number) {
        let secenList = this.scene_id.split(",");
        var sceneSwitch = true;
        if (secenList.indexOf(this.LaunchOptionsSync.scene_id) == -1) {//场景开关
            sceneSwitch = false;
        }
        if (tyqSdkConfig.app_version == 1 && version1 == 0) {
            this.masterSwitch = false;
            this.allSwitch = false;
            return;
        };
        if (tyqSdkConfig.app_version == 2 && version2 == 0) {
            this.masterSwitch = false;
            this.allSwitch = false;
            return;
        };
        //先判断是否经过一天
        const curTime = this.getTimeStamp(true)//精确到日期
        const lastTime = this.getItem("gameTime");
        if (lastTime) {//在上一次的时间 不是第一次进游戏
            //当前时间和上一次游戏时间相等，判断是否缓存了总开关，如果总开 是关着，则总开关为关，如果总开关为开，则进入后面的判断，如果没有缓存，也进入后面的判断
            //缓存的总开关根据场景值判断，如果场景值进过纯净版，则当天都为纯净版
            if (lastTime == curTime) {
                const sw = this.getItem("MasterSwitch");
                if (sw && sw == 2) {//2 是关 ，1是开
                    this.masterSwitch = false;
                    return;
                }
            }
        }

        if (this.master_switch == 0) {//先判断总开关
            this.masterSwitch = false;
            return
        }
        //再判断场景值
        if (!this.LaunchOptionsSync) {
            this.masterSwitch = false;
            return;
        };
        //不存在场景值直接false  只有场景值不为需要的场景值 才进行缓存
        if (!sceneSwitch) {
            this.masterSwitch = false;//当前场景值不是需要的场景值也 false
            this.setItem("MasterSwitch", 2);
            return;
        }
        this.masterSwitch = true;
        this.setItem("MasterSwitch", 1);
    }

    /**登录 */
    private login() {
        const openid = this.getItem("tyq_openid");//获取保存到本地的openid
        var time = this.getTimeStamp();
        time = time.substr(0, 10);//精确到秒
        if (openid) {//
            this.openid = openid;
            var info: any = {
                appid: tyqSdkConfig.appId,
                nonce_str: this.randomStr(),
                time_stamp: time,
                openid: openid,
                login_date: this.getItem("login_date") ? this.getItem("login_date") : "",
                tiktok_id: this.LaunchOptionsSync.query.tiktok_id ? this.LaunchOptionsSync.query.tiktok_id : null,
                video_uuid: this.LaunchOptionsSync.query.video_uuid ? this.LaunchOptionsSync.query.video_uuid : null
            }
            this.tt_login(info);
        } else {//如果用户登录可以获取code，传code和anonymous_code，不能则本地生成一个openID
            var info: any = {
                appid: tyqSdkConfig.appId,
                nonce_str: this.randomStr(),
                time_stamp: time,
                tiktok_id: this.LaunchOptionsSync.query.tiktok_id ? this.LaunchOptionsSync.query.tiktok_id : null,
                video_uuid: this.LaunchOptionsSync.query.video_uuid ? this.LaunchOptionsSync.query.video_uuid : null
            }
            Toutiao.TTLogin((res: any) => {
                if (res.code) {
                    info["code"] = res.code;
                    info["anonymous_code"] = res.anonymousCode
                } else {
                    info["openid"] = this.creatorOpenid();
                }
                this.tt_login(info);
            }, () => {
                info["openid"] = this.creatorOpenid();
                this.tt_login(info);
            })
        }
    }

    /**
 * 登录接口
 * @param info 数据包
 */
    private tt_login(info: any) {
        NetworkMgr.xhrPost("douyin_game_sdk/api/v1/tt_login", info, (cb: any) => {
            console.log(cb);
            if (cb && cb.errcode == 0) {
                this.openid = cb.data.openid
                this.setItem("tyq_openid", this.openid);
                this.setItem("login_date", cb.data.login_date);
            } else {
                setTimeout(() => {//如果返回errocde不等于0得继续请求
                    this.login();
                }, 3000);
            }
        })
    }

    /**创建一个本地的openID */
    private creatorOpenid(): string {
        var data = new Date();
        const curTime = data.getFullYear().toString() + (data.getMonth() + 1).toString() + data.getDate().toString()//精确到日
        let Hours = data.getHours().toString();
        let Min = data.getMinutes().toString();
        let Second = data.getSeconds().toString();
        if (Hours.length == 1) {
            Hours = "0" + Hours;
        }
        if (Min.length == 1) {
            Min = "0" + Min;
        }
        if (Second.length == 1) {
            Second = "0" + Second;
        }
        const randStr = this.randomStr(19);
        const openid = "tyq" + curTime + Hours + Min + Second + randStr;
        this.openid = openid;
        this.setItem("tyq_openid", this.openid);
        return openid;
    }
    /**
     * 收集关卡游玩信息
     * @param stata 胜利或者失败
     */
    private collectLevelInfo(stata?: number) {
        if (!this.openid) return;
        var time = this.getTimeStamp();
        let curTime = Number(time);
        time = time.substr(0, 10);//精确到秒
        if (stata) {//如果有状态 要计算游戏时间
            var play_time = curTime - this._playTime;
            this._playTime = 0;
        } else {
            var play_time = 0;
            this._playTime = curTime;
        }
        let info = {
            appid: tyqSdkConfig.appId,
            nonce_str: this.randomStr(),
            time_stamp: time,
            openid: this.openid,
            game_level: this._gameLevel,
            status: stata ? stata : 1,
            play_time: play_time,
        }
        NetworkMgr.xhrPost("douyin_game_sdk/api/v1/collect_user_play_game_level", info);
    }

    /**初始化广告ID
     * @param rewardedVideoIdArry 视频广告ID数组
     */
    private initAdUnitId(rewardedVideoIdArry: string[]) {
        //初始化banner
        let bannerStr = this.getSwitchValue("bannerID");
        if (bannerStr) {
            const bannerList = bannerStr.split(",");
            Toutiao.bannerAdUnitId = bannerList;
        }
        //初始化插屏
        let interstitialStr = this.getSwitchValue("interstitialID");
        if (interstitialStr) {
            const interstitialList = interstitialStr.split(",");
            Toutiao.interstitialAdUnitId = interstitialList;
        }
        //初始化激励视频
        if (rewardedVideoIdArry && rewardedVideoIdArry.length > 0) {
            // const rewardedVideoList = rewardedVideoStr.split(",");
            Toutiao.rewardedVideoAdUnitId = rewardedVideoIdArry;
        }
    }

    /**初始化互推 */
    private initGameList() {
        const time = this.getTimeStamp(false, true);
        let info = {
            appid: tyqSdkConfig.appId,
            nonce_str: this.randomStr(),
            time_stamp: time,
        }
        NetworkMgr.xhrPost("douyin_game_sdk/api/v1/get_htw_ads", info, (cb: any) => {
            console.log(cb);
            let arr = Object.keys(cb.data);
            if (arr.length <= 1) return;
            this.gameList = [];
            for (let value of cb.data[arr[0]]) {
                let info: gameInfo = {
                    gameName: value.title,
                    gameImg: value.img_name,
                    gameTips: this.RandomNumBoth(5, 888) + "万人最近在玩",
                    gameVideID: value.video_id,
                    gameID: value.htw_ads_id
                }
                this.gameList.push(info);
            }
            for (let value of cb.data[arr[1]]) {
                let info: gameInfo = {
                    gameName: value.title,
                    gameImg: value.img_name,
                    gameTips: this.RandomNumBoth(5, 600) + "万人最近在玩",
                    gameVideID: value.video_id,
                    gameID: value.htw_ads_id
                }
                this.gameBannerList.push(info);
            }
        })
    }

    /**初始化钻石和体力和vip状态 */
    private initDiamondsAndPhysical() {
        let physical = this.getItem("tyq_physical");
        let diamonds = this.getItem("tyq_diamonds");
        let vip = this.getItem("tyq_vip");
        if (!physical) {
            physical = tyqSdkConfig.startPhysical;
        }
        if (!diamonds) {
            diamonds = 0;
        }
        if (!vip) {
            this.vip = false;
            var info = {
                time: this.getTimeStamp(true),
                count: 0
            }
            this.setItem("tyq_vip", info);
        } else {
            const lastTime = vip.time;
            const curTime = this.getTimeStamp(true);
            if (lastTime != curTime) {
                this.vip = false;
                vip.time = curTime;
                vip.count = 0;
            } else {
                if (vip.count >= tyqSdkConfig.vipCount) {
                    this.vip = true;
                }
            }
            this.setItem("tyq_vip", vip);
        }
        this.physical = Number(physical);
        this.diamonds = Number(diamonds);
    }

    /**无操作播放广告 */
    private noOperationPlayAD(num: number) {
        console.log("首页无操作弹出视频");
        this.showVideoAD("首页无操作弹出视频", () => {
            if (this.mainWatch) {
                this.mainWatch = setTimeout(() => {
                    this.noOperationPlayAD(num);
                }, num);
            }
        }, () => {
            if (this.mainWatch) {
                this.mainWatch = setTimeout(() => {
                    this.noOperationPlayAD(num);
                }, num);
            }
        });
    }

    /**
     * 获取时间戳
     * @param date 传true 会返回当前日期（20210929），默认返回精确到毫秒的时间戳
     * @param second 传true 会返回精确到秒的时间戳 ，默认返回精确到毫秒的时间戳
     * @returns 
     */
    public getTimeStamp(date: boolean = false, second: boolean = false): string {
        var data = new Date();
        let time = data.getTime().toString()
        if (!date && !second) {
            return time;//精确到毫秒
        } else if (date) {
            return data.getFullYear().toString() + (data.getMonth() + 1).toString() + data.getDate().toString()//精确到日期
        } else if (!date && second) {
            return time.substr(0, 10);//精确到秒
        }
        return "";
    }

}
export const tyqSDK = tyqSdk._instance;
(<any>window)["TyqSdk"] = tyqSDK;