import { _decorator, Component, Node, LabelComponent, loader, SpriteFrame, SpriteComponent, Asset, Texture2D, ImageAsset, isValid, assetManager } from 'cc';
import { gameInfo, tyqSDK } from './tyq-sdk';
const { ccclass, property } = _decorator;

@ccclass('tyq_gameItem')
/**反正更多游戏面板的item */
export class tyq_gameItem extends Component {

    init(value: gameInfo) {
        this.node.getChildByName("gameName")!.getComponent(LabelComponent)!.string = value.gameName;
        this.node.getChildByName("playNum")!.getComponent(LabelComponent)!.string = value.gameTips;
        this.node.on(Node.EventType.TOUCH_END, () => {
            tyqSDK.navigateToVideoView(value, "游戏盒子");
        }, this);
        if (tyqSDK.gameList.length < 12) return;
        assetManager.loadRemote(value.gameImg, (err: any, spf: ImageAsset) => {
            if (err) {
                console.log(err);
                return;
            };
            const sp = new SpriteFrame();
            const tex = new Texture2D();
            tex.image = spf;
            sp.texture = tex;
            this.node.getComponent(SpriteComponent)!.spriteFrame = sp;
        })

    }
}
