import { _decorator, Component, Node, WidgetComponent, ImageAsset, SpriteFrame, Texture2D, SpriteComponent, loader, SystemEvent, systemEvent, resources, assetManager } from 'cc';
import { SDKbaseView } from './SDKbaseView';
import { gameInfo, tyqSDK } from './tyq-sdk';
const { ccclass, property } = _decorator;

@ccclass('tyq_gameItemMini')
export class tyq_gameItemMini extends SDKbaseView {


    init(from: string, value: gameInfo) {
        // if (TyqSdk.gameList.length < 12) return;
        assetManager.loadRemote(value.gameImg, (err: any, spf: ImageAsset) => {
            if (err) {
                console.log(err);
                return;
            };
            const sp = new SpriteFrame();
            const tex = new Texture2D();
            tex.image = spf;
            sp.texture = tex;
            this.node.getComponent(SpriteComponent)!.spriteFrame = sp;
        })
        this.bindButton(this.node, () => {
            tyqSDK.navigateToVideoView(value, from);
        })

    }


}
