import { _decorator, Component, Node, Prefab, instantiate } from 'cc';
import { SDKbaseView } from './SDKbaseView';
import { tyqSDK } from './tyq-sdk';
import { tyq_gameItem } from './tyq_gameItem';
const { ccclass, property } = _decorator;

@ccclass('tyq_moreGamePanel')
export class tyq_moreGamePanel extends SDKbaseView {

    @property({
        type: Node,
        tooltip: "今日最佳的layout"
    })
    layOut1: Node = null!;

    @property({
        type: Node,
        tooltip: "编辑精选的layout"
    })
    layOut2: Node = null!;
    @property({
        type: Node,
        tooltip: "返回"
    })
    back: Node = null!;

    @property({
        type: Prefab,
        tooltip: "游戏item预制体"
    })
    tyq_gameItem: Prefab = null!;

    start() {
        let arry = tyqSDK.gameList;
        arry.sort(this.randList);

        for (let i = 0; i < 6; i++) {
            const node = instantiate(this.tyq_gameItem);
            node.parent = this.layOut1;
            node.getComponent(tyq_gameItem)!.init(arry[i]);
        }
        if (arry.length < 9) return;
        for (let i = 6; i < arry.length; i++) {
            const node = instantiate(this.tyq_gameItem);
            node.parent = this.layOut2;
            node.getComponent(tyq_gameItem)!.init(arry[i]);
        }
        this.bindButton(this.back,this.backFun);
    }

    /**返回 */
    backFun() {
        tyqSDK.hideMoreGameBoxPanel();
    }

    /**随机数组 */
    randList() {
        return 0.5 - Math.random();
    }

    onEnable() {
        this.node.setSiblingIndex(this.node.parent!.children.length - 1);
    }

}
