
import { _decorator, Component, Node, SpriteFrame, Sprite, Prefab } from 'cc';
import { SDKbaseView } from './SDKbaseView';
import { tyqSDK } from './tyq-sdk';
import { tyq_gameItemMini } from './tyq_gameItemMini';
const { ccclass, property } = _decorator;

@ccclass('tyq_settlePanel')
export class tyq_settlePanel extends SDKbaseView {

    @property({
        type: Sprite,
        tooltip: "title"
    })
    title: Sprite = null!;

    @property({
        type: Sprite,
        tooltip: "胜利或失败的奖励"
    })
    sp: Sprite = null!;

    @property({
        type: SpriteFrame,
        tooltip: "胜利失败title精灵"
    })
    titleSpList: SpriteFrame[] = [];

    @property({
        type: SpriteFrame,
        tooltip: "体力或者钻石奖励精灵 过关体力，失败钻石"
    })
    rewardSpList: SpriteFrame[] = [];
    @property({
        type: Node,
        tooltip: "继续游戏"
    })
    next: Node = null!;
    @property({
        type: Node,
        tooltip: "3倍领取"
    })
    video: Node = null!;

    @property({
        type: Prefab,
        tooltip: "mini游戏盒子"
    })
    tyq_gameItemMini: Prefab = null!;

    @property({
        type: Node,
        tooltip: "小游戏图标的父节点"
    })
    layout: Node = null!;

    init(type: string, nextFun?: Function) {
        tyqSDK.showInterstitialAD();
        if (type == "win") {//胜利奖励体力
            this.title.spriteFrame = this.titleSpList[0];
            this.sp.spriteFrame = this.rewardSpList[0];
            tyqSDK.Physical = 1;
            this.bindButton(this.video, () => {
                this.video.active = false;
                tyqSDK.Physical = 3;
            })
        } else {
            this.title.spriteFrame = this.titleSpList[1];
            this.sp.spriteFrame = this.rewardSpList[1];
            tyqSDK.Diamonds = 1;
            this.bindButton(this.video, () => {
                this.video.active = false;
                tyqSDK.Diamonds = 3;
            })
        }
        this.bindButton(this.next, () => {
            this.node.destroy();
            if (nextFun) {
                nextFun();
            }
        });
        if (tyqSDK.getSwitchInfoByName("miniGameItem")) {//获取开关的小游戏icon显示
            let randList = [];
            while (randList.length < 4) {
                const num = tyqSDK.RandomNumBoth(0, tyqSDK.gameList.length - 1);
                if (randList.indexOf(num) == -1) {
                    randList.push(num);
                }
            }
            for (let value of randList) {
                this.showUI(this.tyq_gameItemMini, this.layout, (comp: tyq_gameItemMini) => {
                    comp.init("结算页面", tyqSDK.gameList[value]);
                })
            }
        }
    }

    // update (deltaTime: number) {
    //     // [4]
    // }
}
