import { _decorator, Component, Node, ButtonComponent, Widget, Button } from 'cc';
import { SDKbaseView } from './SDKbaseView';
import { tyqSDK } from './tyq-sdk';
const { ccclass, property } = _decorator;

@ccclass('tyq_share')
export class tyq_share extends SDKbaseView {

    @property({
        type: Node,
        tooltip: "分享按钮"
    })
    shareBtn: Node = null!;

    @property({
        type: Node,
        tooltip: "分享按钮2"
    })
    shareBtn2: Node = null!;

    @property({
        type: Node,
        tooltip: "下一关按钮"
    })
    next: Node = null!;

    private callback: Function | null = null;
    start() {
        this.bindButtonOce(this.shareBtn, this.shareVideo);
        this.bindButtonOce(this.shareBtn2, this.shareVideo);
        this.bindButtonOce(this.next, this.nextGame);
    }

    init(callBack: Function) {
        this.callback = callBack;
    }

    /**分享视频 */
    shareVideo() {
        tyqSDK.RecordCut();
        this.shareBtn.active = false;
        this.shareVideo = function () { };
    }

    /**下一关 */
    nextGame() {
        if (tyqSDK.getSwitchInfoByName("bannerShare")) {
            // this.next.getComponent(WidgetComponent).enabled = false;
            this.scheduleOnce(() => {
                console.log(this.next.position);
                this.next.getComponent(Widget)!.bottom = 0.15;
                this.next.getComponent(Widget)!.updateAlignment();
                console.log(this.next.position);
                this.bindButton(this.next, this.nextFun);
            }, 1.5)
            tyqSDK.showBannerAD();
        } else {
            this.nextFun();
        }
    }

    /**真正的下一关逻辑 */
    nextFun() {
        if (this.callback) {
            this.callback();
        }
        this.node.destroy();
        tyqSDK.hideBannerAD();
    }
 
    // update (deltaTime: number) {
    //     // Your update function goes here.
    // }
}
